"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs = __importStar(require("mz/fs"));
var path = __importStar(require("path"));
var yargs_1 = __importDefault(require("yargs"));
var _1 = require(".");
var theme_1 = require("./theme");
yargs_1.default
    .usage(['', 'Usage: highlight [options] [file]', '', 'Outputs a file or STDIN input with syntax highlighting'].join('\n'))
    .option('theme', {
    alias: 't',
    nargs: 1,
    description: 'Use a theme defined in a JSON file',
})
    .option('language', {
    alias: 'l',
    nargs: 1,
    description: 'Set the langugage explicitely\nIf omitted will try to auto-detect',
})
    .option('terminator', {
    alias: 'e',
    default: '\0',
    nargs: 1,
    description: 'Set the terminator character',
})
    .version()
    .help('help')
    .alias('help', 'h')
    .alias('version', 'v');
var argv = yargs_1.default.argv;
var filePath = argv._[0];
var highlightTheme = argv.theme ? fs.readFileSync(argv.theme, 'utf8') : undefined;
var options = {
    ignoreIllegals: true,
    theme: (highlightTheme && theme_1.parse(highlightTheme)) || undefined,
};
if (filePath) {
    var fileExtension = path.extname(filePath).slice(1);
    if (fileExtension && _1.supportsLanguage(fileExtension)) {
        options.language = fileExtension;
    }
}
options.language = argv.language;
var printCode = (function (codeString) {
    process.stdout.write(_1.highlight(codeString, options), function (error) { return (error ? console.error(error) : null); });
});
if (!filePath && !process.stdin.isTTY) {
    process.stdin.setEncoding('utf8');
    var code_1 = '';
    process.stdin.on('readable', function () {
        var chunk = process.stdin.read();
        if (chunk !== null) {
            code_1 += chunk;
        }
        if (argv.terminator) {
            var terminator = argv.terminator;
            if (code_1.endsWith(terminator)) {
                printCode(code_1);
                code_1 = '';
            }
        }
    });
    new Promise(function (resolve) {
        process.stdin.on('end', function () {
            var chunk = process.stdin.read();
            if (chunk !== null) {
                code_1 += chunk;
            }
            resolve(code_1);
        });
    })
        .then(function (codeString) {
        printCode(codeString);
        process.exit(0);
    })
        .catch(function (error) {
        console.error(error);
        process.exit(1);
    });
}
else if (filePath) {
    printCode(fs.readFileSync(filePath, 'utf-8'));
    process.exit(0);
}
else {
    yargs_1.default.showHelp();
    process.exit(1);
}
//# sourceMappingURL=cli.js.map